import json
from django.core.management.base import BaseCommand
from entrenadores.models import Entrenador


class Command(BaseCommand):
    help = "Importa entrenadores desde un archivo JSON"

    def add_arguments(self, parser):
        parser.add_argument('archivo_json', type=str, help="Ruta del archivo JSON")

    def handle(self, *args, **kwargs):
        archivo_json = kwargs['archivo_json']

        try:
            with open(archivo_json, 'r', encoding='utf-8') as file:
                datos = json.load(file)

            self.stdout.write(self.style.WARNING(f"\nSe encontraron {len(datos)} entrenadores en el archivo '{archivo_json}'."))
            confirmar = input("¿Deseas continuar con la importación? (s/n): ").strip().lower()

            if confirmar != 's':
                self.stdout.write(self.style.ERROR("Importación cancelada."))
                return

            entrenadores_creados = 0
            for entrenador_data in datos:
                try:
                    entrenador = Entrenador.objects.get(matricula=entrenador_data["entrenador_matricula"])

                    creado = Entrenador.objects.create(
                        entrenador=entrenador,
                        nombre=entrenador_data['nombre']
                    )
                    if creado:
                        entrenadores_creados += 1

                except Entrenador.DoesNotExist:
                    self.stderr.write(self.style.ERROR(f"Entrenador con matrícula '{entrenador_data['entrenador_matricula']}' no encontrado."))

            self.stdout.write(self.style.SUCCESS(f'Se importaron {entrenadores_creados} entrenadores correctamente.'))

        except FileNotFoundError:
            self.stderr.write(self.style.ERROR(f"El archivo {archivo_json} no se encontró."))
        except json.JSONDecodeError:
            self.stderr.write(self.style.ERROR("Error al leer el archivo JSON. Asegúrate de que el formato sea correcto."))
